Package org.apache.sysds.runtime.compress.colgroup.offset

# Class AOffset

java.lang.Object
org.apache.sysds.runtime.compress.colgroup.offset.AOffset

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `AOffsetByte`, `OffsetChar`, `OffsetEmpty`, `OffsetSingle`, `OffsetTwo`

public abstract class AOffset extends Object implements Serializable
Offset list encoder abstract class.

It is assumed that the input is in sorted order, all values are positive and there are no duplicates.

The no duplicate is important since 0 values are exploited to encode an offset of max representable value + 1. This gives the ability to encode data, where the offsets are greater than the available highest value that can be represented size.

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static final class`
`AOffset.OffsetSliceInfo`
Offset slice info containing the start and end index an offset that contains the slice, and an new AOffset containing only the sliced elements
`static final class`
`AOffset.RemoveEmptyOffsetsTmp`

## Constructor Summary

Constructors
Constructor
Description
`AOffset()`

## Method Summary

Modifier and Type
Method
Description
`AOffset`
`append(AOffset t, int s)`
Append the offsets from that other offset to the offsets in this.
`AOffset`
`appendN(AOffsetsGroup[] g, int s)`
Append a list of offsets together in order.
`void`
`cacheIterator(AIterator it, int row)`
Cache a iterator in use, note that there is no check for if the iterator is correctly positioned at the given row
`void`
`clearSkipList()`
`void`
`constructSkipList()`
`boolean`
`equals(Object o)`
`boolean`
`equals(AOffset b)`
`abstract long`
`getExactSizeOnDisk()`
Remember to include the ordinal of the type of offset list.
`abstract long`
`getInMemorySize()`
Get the in memory size of the Offset object
`abstract AIterator`
`getIterator()`
Get an iterator of the offsets while also maintaining the data index pointer.
`AIterator`
`getIterator(int row)`
Get an iterator that is pointing at a specific offset.
`abstract int`
`getLength()`
Get the length of the underlying array.
`abstract AOffsetIterator`
`getOffsetIterator()`
Get an OffsetIterator of current offsets not maintaining the data index.
`abstract int`
`getOffsetToFirst()`
Get the offset to the first index
`abstract int`
`getOffsetToLast()`
Get the offset to the last value
`abstract int`
`getSize()`
Get the number of contained elements, This method iterate the entire offset list, so it is not constant lookup.
`abstract AOffset`
`moveIndex(int m)`
Move the index start x cells
`final void`
`preAggregateDenseMap(DenseBlock db, double[] preAV, int rl, int ru, int cl, int cu, int nVal, AMapToData data)`
Pre aggregate the specified row and block range from a dense MatrixBlock to prepare for compressed multiplication.
`final void`
`preAggSparseMap(SparseBlock sb, double[] preAV, int rl, int ru, int nVal, AMapToData data)`
`AOffset.RemoveEmptyOffsetsTmp`
`removeEmptyRows(boolean[] selectV, int rOut)`
`AOffset`
`reverse(int numRows)`
Reverse the locations of the offsets such that the inverse offsets are returned.
`AOffset.OffsetSliceInfo`
`slice(int l, int u)`
Slice the offsets based on the specified range
`String`
`toString()`
`void`
`verify(int size)`
Verify that the contained AOffset is a certain size, and not bigger when iterating though it.
`abstract void`
`write(DataOutput out)`
Write the offsets to disk.

### Methods inherited from class java.lang.Object

`getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### AOffset

public AOffset()

## Method Details

### getIterator

public abstract AIterator getIterator()
Get an iterator of the offsets while also maintaining the data index pointer.

Returns:
  AIterator that iterate through index and dictionary offset values.

### getOffsetIterator

public abstract AOffsetIterator getOffsetIterator()
Get an OffsetIterator of current offsets not maintaining the data index.

Returns:
  AIterator that iterator through the delta offsets.

### getIterator

public AIterator getIterator(int row)
Get an iterator that is pointing at a specific offset.

Parameters:
  `row` - The row requested.
Returns:
  AIterator that iterate through index and dictionary offset values.

### constructSkipList

public void constructSkipList()

### clearSkipList

public void clearSkipList()

### cacheIterator

public void cacheIterator(AIterator it, int row)
Cache a iterator in use, note that there is no check for if the iterator is correctly positioned at the given row

Parameters:
  `it` - The Iterator to cache
  `row` - The row index to cache the iterator as.

### write

public abstract void write(DataOutput out) throws IOException
Write the offsets to disk. If you implement another remember to write the ordinal of the new type to disk as well and add it to the OffsetFactory.

Parameters:
  `out` - The output to write to
Throws:
  `IOException` - Exception that happens if the IO fails to write.

### getOffsetToFirst

public abstract int getOffsetToFirst()
Get the offset to the first index

Returns:
  The first index offset

### getOffsetToLast

public abstract int getOffsetToLast()
Get the offset to the last value

Returns:
  The last values offset

### getInMemorySize

public abstract long getInMemorySize()
Get the in memory size of the Offset object

Returns:
  In memory size as a long.

### getExactSizeOnDisk

public abstract long getExactSizeOnDisk()
Remember to include the ordinal of the type of offset list.

Returns:
  the size on disk as a long.

### getSize

public abstract int getSize()
Get the number of contained elements, This method iterate the entire offset list, so it is not constant lookup.

Returns:
  The number of indexes.

### preAggregateDenseMap

public final void preAggregateDenseMap(DenseBlock db, double[] preAV, int rl, int ru, int cl, int cu, int nVal, AMapToData data)
Pre aggregate the specified row and block range from a dense MatrixBlock to prepare for compressed multiplication.

Parameters:
  `db` - The DenseBlock to extract values from.
  `preAV` - The pre aggregate row linearized double array to put the values into.
  `rl` - The row lower to start from (this is referring to the left matrix of the multiplication)
  `ru` - The row upper to end at (not inclusive) (this is referring to the left matrix of the multiplication)
  `cl` - The column lower to start at (this is referring to the right matrix of the multiplication)
  `cu` - The column upper to end at (not inclusive) (this is referring to the right matrix of the multiplication)
  `nVal` - The number of distinct values in the PreAV indicating number of columns in the Pre aggregate
  `data` - The mapping to column positions in the preAV

### preAggSparseMap

public final void preAggSparseMap(SparseBlock sb, double[] preAV, int rl, int ru, int nVal, AMapToData data)

### equals

public boolean equals(Object o)

Overrides:
  `equals` in class `Object`

### equals

public boolean equals(AOffset b)

### moveIndex

public abstract AOffset moveIndex(int m)
Move the index start x cells

Parameters:
  `m` - The amount to move
Returns:
  The moved index.

### getLength

public abstract int getLength()
Get the length of the underlying array. This does not reflect the number of contained elements, since some of the elements can be skips.

Returns:
  The length of the underlying arrays

### slice

public AOffset.OffsetSliceInfo slice(int l, int u)
Slice the offsets based on the specified range

Parameters:
  `l` - inclusive lower bound
  `u` - exclusive upper bound
Returns:
  The slice info containing the new slice.

### append

public AOffset append(AOffset t, int s)
Append the offsets from that other offset to the offsets in this.

Parameters:
  `t` - That offset/
  `s` - The total length encoded in this offset.
Returns:
  this offsets followed by thats offsets.

### appendN

public AOffset appendN(AOffsetsGroup[] g, int s)
Append a list of offsets together in order.

Parameters:
  `g` - The offsets to append together (note fist entry is equal to this)
  `s` - The standard size of each g (except last, but that does not matter)
Returns:
  The combined offsets.

### verify

public void verify(int size)
Verify that the contained AOffset is a certain size, and not bigger when iterating though it.

Parameters:
  `size` - The max correct size.

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### reverse

public AOffset reverse(int numRows)
Reverse the locations of the offsets such that the inverse offsets are returned. This means that for instance if the current offsets were 1, 3 and 5 in a 5 long list, we return 0, 2 and 4.

Parameters:
  `numRows` - The total number of rows to be contained, This should be greater or equal to last.
Returns:
  The reverse offsets.

### removeEmptyRows

public AOffset.RemoveEmptyOffsetsTmp removeEmptyRows(boolean[] selectV, int rOut)